<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SR_DevolucionDetalle.xml */
/* Generado: 2021-07-06 18:57:55 */

/* Mantenimiento de los registros de la tabla SR_DevolucionDetalle */
abstract class BaseSR_DevolucionDetalleDP extends SR_DevolucionDetalleBV
{
    /* Constructor ( Establece los valores desde un objeto SR_DevolucionDetalleBN ) */
    public function __construct( SR_DevolucionDetalleBN $o_SR_DevolucionDetalleBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SR_DevolucionDetalleBN ) )
        {
            $this->setByBN( $o_SR_DevolucionDetalleBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SR_DevolucionDetalleBN */
    public function setByBN( SR_DevolucionDetalleBN $o_SR_DevolucionDetalleBN )
    {
        if ( !is_null( $o_SR_DevolucionDetalleBN->getDevolucionDetId() ) )
        {
            $this->setDevolucionDetId( $o_SR_DevolucionDetalleBN->getDevolucionDetId() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getDevolucionCabId() ) )
        {
            $this->setDevolucionCabId( $o_SR_DevolucionDetalleBN->getDevolucionCabId() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getEstadoDevolucionId() ) )
        {
            $this->setEstadoDevolucionId( $o_SR_DevolucionDetalleBN->getEstadoDevolucionId() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getIdItem() ) )
        {
            $this->setIdItem( $o_SR_DevolucionDetalleBN->getIdItem() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getItemDescripcion() ) )
        {
            $this->setItemDescripcion( $o_SR_DevolucionDetalleBN->getItemDescripcion() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getCantidadDevolucion() ) )
        {
            $this->setCantidadDevolucion( $o_SR_DevolucionDetalleBN->getCantidadDevolucion() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getComentarioDevolucion() ) )
        {
            $this->setComentarioDevolucion( $o_SR_DevolucionDetalleBN->getComentarioDevolucion() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getTipoComentDevolucion() ) )
        {
            $this->setTipoComentDevolucion( $o_SR_DevolucionDetalleBN->getTipoComentDevolucion() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getEstadoFacturacion() ) )
        {
            $this->setEstadoFacturacion( $o_SR_DevolucionDetalleBN->getEstadoFacturacion() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getDevolFactId() ) )
        {
            $this->setDevolFactId( $o_SR_DevolucionDetalleBN->getDevolFactId() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getPrecioUnitVentaDevolucion() ) )
        {
            $this->setPrecioUnitVentaDevolucion( $o_SR_DevolucionDetalleBN->getPrecioUnitVentaDevolucion() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SR_DevolucionDetalleBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SR_DevolucionDetalleBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SR_DevolucionDetalleBN->getUsuarioCreacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SR_DevolucionDetalleFN = new SR_DevolucionDetalleFN();
        $o_SR_DevolucionDetalleBN = $o_SR_DevolucionDetalleFN->selectByPk( $this->getDevolucionDetId() );
        if ( is_null( $o_SR_DevolucionDetalleBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SR_DevolucionDetalle ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getDevolucionDetId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DevolucionDetId";
                $s_SQLQuery2 .= $s_Separator."".$this->getDevolucionDetId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDevolucionCabId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DevolucionCabId";
                $s_SQLQuery2 .= $s_Separator."".$this->getDevolucionCabId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoDevolucionId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EstadoDevolucionId";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstadoDevolucionId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getItemDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ItemDescripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getItemDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadDevolucion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadDevolucion";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadDevolucion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentarioDevolucion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ComentarioDevolucion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getComentarioDevolucion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoComentDevolucion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoComentDevolucion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoComentDevolucion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoFacturacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EstadoFacturacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstadoFacturacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDevolFactId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DevolFactId";
                $s_SQLQuery2 .= $s_Separator."".$this->getDevolFactId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitVentaDevolucion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitVentaDevolucion";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitVentaDevolucion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SR_DevolucionDetalle SET ";
            $s_Separator = "";
            if ( !is_null( $this->getDevolucionCabId() ) )
            {
                $s_SQLQuery .= $s_Separator."DevolucionCabId = ".$this->getDevolucionCabId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoDevolucionId() ) )
            {
                $s_SQLQuery .= $s_Separator."EstadoDevolucionId = '".$this->getEstadoDevolucionId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getItemDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."ItemDescripcion = '".$this->getItemDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadDevolucion() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadDevolucion = ".$this->getCantidadDevolucion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentarioDevolucion() ) )
            {
                $s_SQLQuery .= $s_Separator."ComentarioDevolucion = '".$this->getComentarioDevolucion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoComentDevolucion() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoComentDevolucion = '".$this->getTipoComentDevolucion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoFacturacion() ) )
            {
                $s_SQLQuery .= $s_Separator."EstadoFacturacion = '".$this->getEstadoFacturacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDevolFactId() ) )
            {
                $s_SQLQuery .= $s_Separator."DevolFactId = ".$this->getDevolFactId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitVentaDevolucion() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitVentaDevolucion = ".$this->getPrecioUnitVentaDevolucion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  DevolucionDetId = ".$this->getDevolucionDetId().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SR_DevolucionDetalle WHERE  DevolucionDetId = ".$this->getDevolucionDetId().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>